﻿
Imports System.IO
Imports System.Drawing
Imports System.Drawing.Imaging
Partial Class VB
    Inherits System.Web.UI.Page


    Protected Sub Upload(sender As Object, e As EventArgs)
        Dim watermarkText As String = "© ASPSnippets.com"

        'Get the file name.
        Dim fileName As String = Path.GetFileNameWithoutExtension(FileUpload1.PostedFile.FileName) + ".png"

        'Read the File into a Bitmap.
        Using bmp As New Bitmap(FileUpload1.PostedFile.InputStream, False)
            Using grp As Graphics = Graphics.FromImage(bmp)
                'Set the Color of the Watermark text.
                Dim brush As Brush = New SolidBrush(Color.Red)

                'Set the Font and its size.
                Dim font As Font = New System.Drawing.Font("Arial", 30, FontStyle.Bold, GraphicsUnit.Pixel)

                'Determine the size of the Watermark text.
                Dim textSize As New SizeF()
                textSize = grp.MeasureString(watermarkText, font)

                'Position the text and draw it on the image.
                Dim position As New Point((bmp.Width - (CInt(textSize.Width) + 10)), (bmp.Height - (CInt(textSize.Height) + 10)))
                grp.DrawString(watermarkText, font, brush, position)

                Using memoryStream As New MemoryStream()
                    'Save the Watermarked image to the MemoryStream.
                    bmp.Save(memoryStream, ImageFormat.Png)
                    memoryStream.Position = 0

                    'Start file download.
                    Response.Clear()
                    Response.ContentType = "image/png"
                    Response.AddHeader("Content-Disposition", Convert.ToString("attachment; filename=") & fileName)

                    'Write the MemoryStream to the Response.
                    memoryStream.WriteTo(Response.OutputStream)
                    Response.Flush()
                    Response.Close()
                    Response.[End]()
                End Using
            End Using
        End Using
    End Sub

End Class
